export default class AddValueRequest {
   value1?: number;
   value2?: number;

   constructor(init?:Partial<AddValueRequest>){
      if(init){
         if(init["value1"])
            this.value1 = init["value1"];
         if(init["value2"])
            this.value2 = init["value2"];
      }
   }


   static verify(data: AddValueRequest){
      return verify_AddValueRequest(data);
   }
}

export function verify_AddValueRequest(data: AddValueRequest): boolean {
   if(data["value1"] !== null && data["value1"] !== undefined ) {
      if(typeof data["value1"] !== "number") return false;
   }

   if(data["value2"] !== null && data["value2"] !== undefined ) {
      if(typeof data["value2"] !== "number") return false;
   }

   return true
}