import TestAtom, { verify_TestAtom } from "./TestAtom";
import TestEnum, { verify_TestEnum } from "./TestEnum";
export default class Test {
   atom?: TestAtom;
   array?: TestAtom[];
   enumValue?: TestEnum;
   map?: Map<number, TestAtom>;

   constructor(init?:Partial<Test>){
      if(init){
         if(init["atom"])
            this.atom = init["atom"];
         if(init["array"])
            this.array = init["array"];
         if(init["enumValue"])
            this.enumValue = init["enumValue"];
         if(init["map"])
            this.map = init["map"];
      }
   }


   static verify(data: Test){
      return verify_Test(data);
   }
}

export function verify_Test(data: Test): boolean {
   if(data["atom"] !== null && data["atom"] !== undefined ) {
      if(!verify_TestAtom(data["atom"])) return false;
   }

   if(data["array"] !== null && data["array"] !== undefined ) {
      if(!Array.isArray(data["array"])) return false
      for(const elm of data["array"]) {
      if(!verify_TestAtom(elm)) return false;
      }
   }

   if(data["enumValue"] !== null && data["enumValue"] !== undefined ) {
      if(!verify_TestEnum(data["enumValue"])) return false;
   }

   if(data["map"] !== null && data["map"] !== undefined ) {
      if(typeof data["map"] !== "object") return false
      for(const key in data["map"]) {
      if(!verify_TestAtom(data["map"][key])) return false;
      }
   }

   return true
}