export default class TestAtom {
   val_number?: number;
   val_boolean?: boolean;
   val_string?: string;

   constructor(init?:Partial<TestAtom>){
      if(init){
         if(init["val_number"])
            this.val_number = init["val_number"];
         if(init["val_boolean"])
            this.val_boolean = init["val_boolean"];
         if(init["val_string"])
            this.val_string = init["val_string"];
      }
   }


   static verify(data: TestAtom){
      return verify_TestAtom(data);
   }
}

export function verify_TestAtom(data: TestAtom): boolean {
   if(data["val_number"] !== null && data["val_number"] !== undefined ) {
      if(typeof data["val_number"] !== "number") return false;
   }

   if(data["val_boolean"] !== null && data["val_boolean"] !== undefined ) {
      if(typeof data["val_boolean"] !== "boolean") return false;
   }

   if(data["val_string"] !== null && data["val_string"] !== undefined ) {
      if(typeof data["val_string"] !== "string") return false;
   }

   return true
}