import AddValueResponse, { verify_AddValueResponse } from "./AddValueResponse";
import AddValueRequest, { verify_AddValueRequest } from "./AddValueRequest";
export type {
   AddValueResponse,
   AddValueRequest,
}
import { verify_number, verify_string, verify_boolean, verify_void } from "./service_base";
import { Service, ServiceProvider, getRandomID } from "./service_client";

export class TestService extends Service {
   constructor(provider: ServiceProvider){
      super(provider, "TestService");
   }
   AddValuesSingleParam(request: AddValueRequest): Promise<AddValueResponse> {
      return new Promise<AddValueResponse>((ok, err) => {
         this._provider.sendMessage({
            jsonrpc: "2.0",
            id: getRandomID(16),
            method: "TestService.AddValuesSingleParam",
            params: [...arguments]
         }, {
            ok, err
         });
      }).then(result => {
         if(!verify_AddValueResponse(result)) throw new Error("Invalid result data!");
         return result;
      });
   }

   AddValuesMultipleParams(value1: number,value2: number): Promise<number> {
      return new Promise<number>((ok, err) => {
         this._provider.sendMessage({
            jsonrpc: "2.0",
            id: getRandomID(16),
            method: "TestService.AddValuesMultipleParams",
            params: [...arguments]
         }, {
            ok, err
         });
      }).then(result => {
         if(!verify_number(result)) throw new Error("Invalid result data!");
         return result;
      });
   }

   ReturningVoid(param1: number): Promise<void> {
      return new Promise<void>((ok, err) => {
         this._provider.sendMessage({
            jsonrpc: "2.0",
            id: getRandomID(16),
            method: "TestService.ReturningVoid",
            params: [...arguments]
         }, {
            ok, err
         });
      }).then(result => {
         if(!verify_void(result)) throw new Error("Invalid result data!");
         return result;
      });
   }

   OnEvent(param1: string): void {
      this._provider.sendMessage({
         jsonrpc: "2.0",
         method: "TestService.OnEvent",
         params: [...arguments]
      });
   }

}