import AddValueResponse, { verify_AddValueResponse } from "./AddValueResponse";
import AddValueRequest, { verify_AddValueRequest } from "./AddValueRequest";
export type {
   AddValueResponse,
   AddValueRequest,
}
import { Service } from "./service_server";
import { verify_number, verify_string, verify_boolean, verify_void } from "./service_base";

export abstract class TestService<T> extends Service<T> {
   public name = "TestService";
   constructor(){
      super();
      this.functions.add("AddValuesSingleParam")
      this.functions.add("AddValuesMultipleParams")
      this.functions.add("ReturningVoid")
      this.functions.add("OnEvent")
   }

   abstract AddValuesSingleParam(request: AddValueRequest, ctx: T): Promise<AddValueResponse>;
   _AddValuesSingleParam(params: any[] | any, ctx: T): Promise<AddValueResponse> {
      let p: any[] = [];
      if(Array.isArray(params)){
         p = params;
      } else {
         p.push(params["request"])
      }
      
      if(p[0] !== null && p[0] !== undefined) {
      if(!verify_AddValueRequest(p[0])) throw new Error("Parameter verification failed!")
      }
      
      p.push(ctx);
      return this.AddValuesSingleParam.call(this, ...p);
   }

   abstract AddValuesMultipleParams(value1: number, value2: number, ctx: T): Promise<number>;
   _AddValuesMultipleParams(params: any[] | any, ctx: T): Promise<number> {
      let p: any[] = [];
      if(Array.isArray(params)){
         p = params;
      } else {
         p.push(params["value1"])
         p.push(params["value2"])
      }
      
      if(p[0] !== null && p[0] !== undefined) {
      if(!verify_number(p[0])) throw new Error("Parameter verification failed!")
      }
      if(p[1] !== null && p[1] !== undefined) {
      if(!verify_number(p[1])) throw new Error("Parameter verification failed!")
      }
      
      p.push(ctx);
      return this.AddValuesMultipleParams.call(this, ...p);
   }

   abstract ReturningVoid(param1: number, ctx: T): Promise<void>;
   _ReturningVoid(params: any[] | any, ctx: T): Promise<void> {
      let p: any[] = [];
      if(Array.isArray(params)){
         p = params;
      } else {
         p.push(params["param1"])
      }
      
      if(p[0] !== null && p[0] !== undefined) {
      if(!verify_number(p[0])) throw new Error("Parameter verification failed!")
      }
      
      p.push(ctx);
      return this.ReturningVoid.call(this, ...p).then(res => undefined);
   }

   abstract OnEvent(param1: string, ctx: T): void;
   _OnEvent(params: any[] | any, ctx: T): void {
      let p: any[] = [];
      if(Array.isArray(params)){
         p = params;
      } else {
         p.push(params["param1"])
      }
      
      if(p[0] !== null && p[0] !== undefined) {
      if(!verify_string(p[0])) throw new Error("Parameter verification failed!")
      }
      
      p.push(ctx);
      return this.OnEvent.call(this, ...p);
   }

}